<?php
/**
 * @package WordPress
 * @subpackage Warmth_Theme
 * @description: function in this files is compatibility for wordpress version before.
 */
?>
<?php
//Begin for wordpress compatibility

if( !function_exists('automatic_feed_links')) :
//since 2.8.0
function automatic_feed_links( $add = true ) {
	if ( $add )
		add_action( 'wp_head', 'w_feed_links', 2 );
	else {
		remove_action( 'wp_head', 'w_feed_links', 2 );
	}
}

function w_feed_links() {
	echo '<link rel="alternate" type="application/rss+xml" title="'. get_bloginfo('name') .' RSS Feed" href="'. get_bloginfo('rss2_url') . "\" />\n";
}
endif;

automatic_feed_links();

if( !function_exists('body_class')) :
//since 2.8.0
function body_class() {
}
endif;

if( !function_exists('get_search_form')) :
//since 2.7.0
function get_search_form() {
	if ( file_exists(STYLESHEETPATH . "/searchform.php")) {
		$template = STYLESHEETPATH . "/searchform.php";
		require($template);
	}else if ( file_exists(TEMPLATEPATH . "/searchform.php") ){
		$template = TEMPLATEPATH . "/searchform.php";
		require($template);
	}
	return;
}
endif;

if( !function_exists('esc_attr')) :
//since 2.8.0
function esc_attr( $text ) {
	return $text;
}
endif;

if( !function_exists('post_class')) :
//since 2.7.0
function post_class() {
	echo 'class="post"';
}
endif;

if( !function_exists('post_password_required')) :
//since 2.7.0
function post_password_required( $post = null ) {
	$post = get_post($post);

	if ( empty($post->post_password) )
		return false;

	if ( !isset($_COOKIE['wp-postpass_' . COOKIEHASH]) )
		return true;

	if ( $_COOKIE['wp-postpass_' . COOKIEHASH] != $post->post_password )
		return true;

	return false;
}
endif;

if( !function_exists('language_attributes')) :
//since 2.1.0
function language_attributes() {
	$output = '';
	if ( $dir = get_bloginfo('text_direction') )
		$output = "dir=\"$dir\"";
	if ( $lang = get_bloginfo('language') ) {
		if ( $dir ) $output .= ' ';
		if ( get_option('html_type') == 'text/html' )
			$output .= "lang=\"$lang\"";
		else $output .= "xml:lang=\"$lang\"";
	}

	echo $output;
}
endif;

if( !function_exists('get_search_query')) :
//since
function get_search_query(){
	global $s;
	return wp_specialchars($s, 1);
}
endif;

if( !function_exists('the_title_attribute')) :
//since 2.3.0
function the_title_attribute() {
	the_title();
}
endif;

if( !function_exists('wp_list_categories')) :
//since 2.1.0
function wp_list_categories( $args = '' ) {
	echo '<li><h2>Categories</h2><ul>';
	wp_list_cats($args);
	echo '</ul></li>';
}
endif;

if( !function_exists('wp_list_bookmarks')) :
//since 2.1.0
function wp_list_bookmarks($args = '') {
	get_links_list();
}
endif;

if( !function_exists('wp_nav_menu')) :
//since 3.0.0
function wp_nav_menu(){
	header_nav_menu();
}
endif;

if( !function_exists('get_template_part')) :
//since 3.0.0
function get_template_part( $slug, $var = null ){
	global $posts, $post, $wp_did_header, $wp_did_template_redirect, $wp_query, $wp_rewrite, $wpdb, $wp_version, $wp, $id, $comment, $user_ID;

	if( is_array( $var ) )
		extract( $var, EXTR_SKIP );

	if( is_array( $wp_query->query_vars ) )
		extract( $wp_query->query_vars, EXTR_SKIP );

	if(file_exists(STYLESHEETPATH . '/' . $slug . '.php')){
		$located = STYLESHEETPATH . '/' . $slug . '.php';
	}elseif( file_exists(TEMPLATEPATH . '/' . $slug . '.php')){
		$located = TEMPLATEPATH . '/' . $slug . '.php';
	}else{
		return false;
	}

	include($located);
}
endif;
/*
if( !function_exists('get_the_date')) :
//since 3.0.0
//remove 3.0.1
function get_the_date( $d = '' ) {
	global $post;
	$the_date = '';

	if ( '' == $d )
		$the_date .= mysql2date(get_option('date_format'), $post->post_date);
	else
		$the_date .= mysql2date($d, $post->post_date);

	return apply_filters('get_the_date', $the_date, $d);
}
endif;
*/

if( !function_exists('esc_attr__')) :
//since 2.8.0
function esc_attr__( $text, $domain = 'default' ) {
	return __( $text, $domain );
}
endif;

if( !function_exists('get_the_author_meta')) :
function get_the_author_meta($field = '', $user_id = false) {
	if ( ! $user_id )
		global $authordata;
	else
		$authordata = get_userdata( $user_id );

	$field = strtolower($field);
	$user_field = "user_$field";

	if ( 'id' == $field )
		$value = isset($authordata->ID) ? (int)$authordata->ID : 0;
	elseif ( isset($authordata->$user_field) )
		$value = $authordata->$user_field;
	else
		$value = isset($authordata->$field) ? $authordata->$field : '';
}
endif;
//End for Wordpress Compatibility
?>