<?php
/**
 * @package WordPress
 * @subpackage Warmth_Theme
 */
?>
<?php

$warmth_options = array();
$warmth_db_options = 'wamrththemeoption';
$default_warmth_options = array(
	'excerpt' => '',
	'fragmentnum' => '4',
	'wordnum' => '300',
	'rss_url_c' => '',
	'rss_url' => '',
	'comment_submit' => '',
	'ad1_c' => '',
	'ad1_text' => '',
	'ad1_float' => '0',
	'ad2_c' => '',
	'ad2_text' => '',
	'webanalysis_c' => '',
	'webanalysis_text' => '',
	'cse_search_c' => '',
	'cse_search_cx' => '',
	'rel_post_c' => '',
	'rel_post_num' => '5',
	'rel_post_feed_c' => '',
	'rand_post_c' => '',
	'rand_post_num' => '5',
	'rand_post_feed_c' => '',
	'db_version' => 1
);

$warmth_options = get_option($warmth_db_options);
if($warmth_options === false)
	$warmth_options = array();
if(!isset($warmth_options['db_version']) || intval($warmth_options['db_version']) < $default_warmth_options['db_version']){
	$warmth_options = array_merge($default_warmth_options,$warmth_options);
	$warmth_options['db_version'] = $default_warmth_options['db_version'];
	if(strcmp($wp_version,'2.3')<0)
		$warmth_options['rel_post_c'] = '';
	update_option($warmth_db_options, $warmth_options);
}

//set content_width for image
if (!isset($content_width))
	$content_width = 620;

// compatibility wordpress some function
//here can't use get_template_part, because this file is compatibility for previous version.
include_once(w_file('compatibility.php'));

function w_theme_init(){
	load_theme_textdomain('warmth', get_template_directory() . '/languages');
}
add_action ('init', 'w_theme_init');

if(is_admin())
	include(w_file('options.php'));

//dynamic sidebar (widget)
if ( function_exists('register_sidebar') ) {
	register_sidebar(array(
		'name' => sprintf(__('Sidebar %s'), 'Right' ),
		'id' => "sidebar-1",
		'before_widget' => '<li id="%1$s" class="sidebar widget %2$s">',
		'after_widget' => '</li>',
		'before_title' => '<h2 class="widgettitle">',
		'after_title' => '</h2>',
	));
}
//end widget

//add theme support
if(function_exists('add_theme_support')){
	add_theme_support('post-thumbnails');
	add_theme_support('automatic-feed-links');
	add_theme_support('menus');
}
//end theme support
//add register_nav_menu
if ( function_exists( 'register_nav_menu' ) ) {
	register_nav_menu('header_nav_menu', __('header menu', 'warmth'));
}
//end register_nav_menu

//orginal header menu
function header_nav_menu(){
?>
<ul>
	<li><a href="<?php bloginfo('url'); ?>"><span>Home</span></a></li>
	<?php w_wp_list_pages('title_li=&depth=1&link_before=<span>&link_after=</span>'); ?>
</ul>
<?php
}

/*
function w_show_random_posts ($limit = 5, $show_pass_post = false) {
    global $wpdb, $tableposts, $wp_query;
    $sql = "SELECT SQL_CALC_FOUND_ROWS  wp_posts.* FROM $tableposts WHERE post_status = 'publish' AND post_type = 'post' AND post_password ='' ORDER BY RAND() LIMIT $limit";
	$result	= $wpdb->get_results($sql);
	foreach($result as $k => $v){
		$result[$k]->post_content = w_CJK_excerpt($v->post_content,1,100);
	}
    $wp_query->posts = $result;
	$wp_query->post_count = $limit;
}
*/
//random posts
function w_random_posts ($limit = 5, $before = '<ul>', $after = '</ul>', $show_date = false) {
    global $wpdb, $wp_version;
    $sql = "SELECT ID, post_title, post_date, post_content FROM {$wpdb->posts}";
	if(strcmp($wp_version,'2.1') < 0){
		$sql .= " WHERE post_status = 'publish' ";
	}else{
		$sql .= " WHERE post_status = 'publish' AND post_type = 'post' ";
	}
	if(true) $sql .= "AND post_password ='' ";
	$sql .= "ORDER BY RAND() LIMIT $limit";
    $posts = $wpdb->get_results($sql);
	if(!is_array($posts)) return;
	$output = '';
    foreach ($posts as $post) {
		$post_title = stripslashes($post->post_title);
		$permalink = get_permalink($post->ID);

		$output .= '<li><a href="' . $permalink . '" rel="bookmark" title="Read ' . str_replace('"', '', $post_title) . '">' . $post_title . '</a>';
		if($show_date)
			$output .= '(' . mysql2date('Y-n-j', $post->post_date) . ')';
		$output .= '</li>';
	}
	return $before . $output . $after;	
}
//random posts

//为不支持mb_strlen()函数的空间自定义一个该函数
if ( !function_exists('mb_strlen') ) {
	function mb_strlen ($text, $encode) {
		if ($encode=='UTF-8') {
			return preg_match_all('%(?:
					  [\x09\x0A\x0D\x20-\x7E]           # ASCII
					| [\xC2-\xDF][\x80-\xBF]            # non-overlong 2-byte
					|  \xE0[\xA0-\xBF][\x80-\xBF]       # excluding overlongs
					| [\xE1-\xEC\xEE\xEF][\x80-\xBF]{2} # straight 3-byte
					|  \xED[\x80-\x9F][\x80-\xBF]       # excluding surrogates
					|  \xF0[\x90-\xBF][\x80-\xBF]{2}    # planes 1-3
					| [\xF1-\xF3][\x80-\xBF]{3}         # planes 4-15
					|  \xF4[\x80-\x8F][\x80-\xBF]{2}    # plane 16
					)%xs',$text,$out);
		}else{
			return strlen($text);
		}
	}
}

function w_getrelateposts($tags,$limit = 5){
	global $wpdb,$post;
	if (!is_array($tags) || (is_array($tags) && !count($tags))) return false;
	$now = current_time('mysql',1);
	$tag_list = implode(",",$tags);
	if ($limit > 0)
		$limitc = " LIMIT $limit";
	else
		$limitc = "";

	if ($post->ID)
		$exclude_post = " AND p.ID != $post->ID";
	else
		$exclude_post = "";

	$q = "SELECT p.*, COUNT(p2t.object_id) AS cnt 
			FROM $wpdb->posts AS p, $wpdb->term_taxonomy AS t, $wpdb->term_relationships AS p2t 
			WHERE p2t.term_taxonomy_id = t.term_taxonomy_id 
			AND t.taxonomy = 'post_tag' 
			AND p2t.object_id = p.ID 
			AND (t.term_id IN ($tag_list)) 
			AND p.post_date_gmt < '$now' 
			AND p.post_type = 'post' 
			AND p.post_status = 'publish' 
			$exclude_post 
			GROUP BY p2t.object_id 
			ORDER BY cnt DESC, p.post_date_gmt DESC $limitc";
	return $wpdb->get_results($q);
}

function w_showrelatedpost($limit=5,$before='<ul>',$after='</ul>'){
	if(!function_exists('get_the_tags'))
		return false;
	$tags = get_the_tags();

	if (empty($tags))
		//return $before . "<li>post have no tags</li>" . $after;
		return false;
	$tag_ids = array();
	foreach ($tags as $tag){
		array_push($tag_ids,$tag->term_id);
	}
	$rps = w_getrelateposts($tag_ids,$limit);
	if (empty($rps))
		//return $before . "<li>this post have no related</li>" . $after;
		return false;
	$out = '';
	foreach ($rps as $rp){
		$out .= sprintf('<li><a href="%s">%s</a></li>',get_permalink($rp->ID),apply_filters('the_title', $rp->post_title, '', ''));
	}
	return $before . $out . $after;
}

//post excerpt
function w_CJK_excerpt ($text,$fragmentnum=-1,$wordnum=-1) {
	global $post,$warmth_options;
	//段落数
	if($fragmentnum < 0)
		$fragmentnum = intval($warmth_options['fragmentnum']) < 1 ? 4 : intval($warmth_options['fragmentnum']);
	//文字数
	if($wordnum < 0)
		$wordnum = intval($warmth_options['wordnum']) < 50 ? 300 : intval($warmth_options['wordnum']);
	$words = explode("\n", $text,$fragmentnum+1);

	if ( ($countnum = mb_strlen(preg_replace('/\s/','',html_entity_decode(strip_tags($text))),'UTF-8')) > $wordnum && count($words) > $fragmentnum && !is_feed() && !is_single() && !is_page() ) {
		$text = strip_tags($text,'<br><p>');
		$text = trim($text);
		$words = explode("\n", $text,$fragmentnum+1);
		$num = 0;
		$output = '';
		do {
			$output = $output . $words[$num] . "\n";
			$num++;
		} while ( (mb_strlen($output, 'UTF-8') < $wordnum) and ($num < $fragmentnum) );

		if (mb_strlen($output, 'UTF-8') < mb_strlen($text, 'UTF-8')) $output .= '<p><a href="' . get_permalink() . '" title="' . strip_tags(get_the_title()) . '">' . __('Read the rest of this entry ', 'warmth') . '&#187;</a></p>';
		$text = $output;

	}

	return $text;

}

if($warmth_options['excerpt'] === 'yes')
	add_filter('the_content', 'w_CJK_excerpt',1);
//end post excerpt

//Begin Archives
if(isset($_GET['waction']) && stripslashes($_GET['waction'])==='loadarchives'){
	add_action('template_redirect','load_archives',99999);
}

function load_archives(){
	include(get_query_template('archives'));
	die();
}
//End Archives

//Begin Recent Comments
function w_get_recent_comments($no_comments = 5, $before = '<li>', $after = '</li>') {

	global $wpdb;

    $comments = $wpdb->get_results("SELECT comment_ID, comment_post_ID, comment_content, comment_author FROM $wpdb->comments WHERE comment_type = '' AND comment_approved = '1' ORDER BY comment_date_gmt DESC LIMIT $no_comments");
    $output = '<li><h2>Recent Comments</h2><ul class="n_height">';
    foreach ($comments as $comment) {
       $comment_author = stripslashes($comment->comment_author);
       $comment_content = strip_tags($comment->comment_content);
       $comment_content = stripslashes($comment_content);
       $comment_excerpt =substr($comment_content,0,40);
       $comment_excerpt = w_utf8_trim($comment_excerpt);
       $permalink = get_permalink($comment->comment_post_ID)."#comment-".$comment->comment_ID;
       $output .= $before . '' . $comment_author . ': <br /><small><a href="' . $permalink . '" title="View the entire comment by ' . $comment_author . '">' . $comment_excerpt . ' ...&#187;</a></small>' . $after;
       }
	   $output .= '</ul></li>';
       echo $output;
} 

function w_utf8_trim($str) {

	$len = strlen($str);

	$hex = '';

	for ($i=strlen($str)-1; $i>=0; $i-=1){
		$hex .= ' '.ord($str[$i]);
		$ch = ord($str[$i]);
        if (($ch & 128)==0) return(substr($str,0,$i));
		if (($ch & 192)==192) return(substr($str,0,$i));
	}
	return($str.$hex);
}
//End Recent Comments

function w_st_tag_cloud($args="",$color=true){
	parse_str($args, $arga);

	$sm = (isset($arga['smallest']) && intval($arga['smallest'])) ? intval($arga['smallest']) : 8;
	$bg = (isset($arga['largest']) && intval($arga['largest'])) ? intval($arga['largest']) : 16;
	unset($arga);

	if(function_exists('st_tag_cloud')){
		$string = st_get_tag_cloud($args);
	}elseif(function_exists('wp_tag_cloud')){
		ob_start();
		ob_clean();

		wp_tag_cloud($args);

		$string = ob_get_contents();
		ob_end_clean();

		$string = "<div class=\"st-tag-cloud\">" . $string . '</div>';
	}else{
		return false;
	}

	if(!$color)
		return $string;

	if(preg_match_all('%<a .*?</a>%xs', $string, $out)){
		foreach($out[0] as $val){
			$r = dechex(rand(0,255));
			$g = dechex(rand(40,196));
			$b = dechex(rand(0,255));
			if (strlen($r) == 1) $r = '0'.$r;
			//if (strlen($g) == 1) $g = '0'.$g;
			if (strlen($b) == 1) $b = '0'.$b;
			if(preg_match("/color:#[0-9a-f]{6}/iu", $val))
				$val = preg_replace("/color:#[0-9a-f]{6}/iu", "color:#$r$g$b", $val);
			else
				$val = preg_replace("/font-size:/iu", "color:#$r$g$b;font-size:", $val);
			$s[] = preg_replace("/font-size: *\d\d?/iu", "font-size:".rand($sm,$bg), $val);
		}
		return '<div class="st-tag-cloud">' . implode("\n",$s) . '</div>';
	}else{
		return $strings;
	}
}

function w_wp_list_pages($args = ''){
	$string = wp_list_pages($args . '&echo=');
	if(!preg_match("%</span></a>%iu",$string)){
		$string = preg_replace("%(<a[^>]*>)%iu", "$1<span>", $string);
		$string = preg_replace("%</a>%iu", "</span></a>", $string);
	}
	echo $string;
}

function wpthreadcomment_threadedcomment($deep=0,$count=0){
?>
	<div class="comment-child<?php echo $deep = 1 ? ' children' : ''; echo $deep%2 ? ' chalt' : ''; ?>" id="comment-<?php comment_ID(); ?>">
		<?php if( function_exists('get_avatar') ) echo get_avatar( $comment, 32 ); ?>
			<cite><?php comment_author_link() ?></cite> Says:
			<?php if ($comment->comment_approved == '0') : ?>
				<em><?php _e('Your comment is awaiting moderation.','warmth'); ?></em>
			<?php endif; ?>
			<br />
			<div class="comment-meta commentmetadata"><small><a href="#comment-<?php comment_ID() ?>" title=""></a><?php comment_date('F jS, Y') ?> at <?php comment_time() ?> <?php edit_comment_link(__('(Edit)','warmth'),'&nbsp;&nbsp;',''); ?></small></div>
			<?php comment_text() ?>
	</div>
<?php
}

function w_file($file){
	if(file_exists(STYLESHEETPATH . '/' . $file)){
		return STYLESHEETPATH . '/' . $file;
	}elseif(file_exists(TEMPLATEPATH . '/' . $file)){
		return TEMPLATEPATH . '/' . $file;
	}else{
		return false;
	}
}

if($warmth_options['rel_post_feed_c'] === 'yes' || $warmth_options['rand_post_feed_c'] === 'yes')
	add_filter('the_content','w_feed_content',999);

function w_feed_content($content){
	global $warmth_options;
	if(is_feed()){
		if($warmth_options['rel_post_feed_c'] === 'yes'){
			$content .= w_showrelatedpost(5,'<div class="relatedposts"><h3>' . __('Extended reading', 'warmth') . '</h3><ul>','</ul></div><div class="dotted"></div>');
		}
		if($warmth_options['rand_post_feed_c'] === 'yes'){
			$content .= w_random_posts(5,'<div class="relatedposts"><h3>' . __('Random Read', 'warmth') . '</h3><ul>','</ul></div><div class="dotted"></div>');

		}
	}
	return $content;
}
?>