<?php
//option page
global $warmth_options, $warmth_db_options, $default_warmth_options;

function displayMessage($message='',$status='') {
	if ($message != ''){
?>
<div id="message" class="<?php echo $status; ?>">
	<p><b><?php echo $message; ?></b></p>
</div>
<?php	
	}
	unset($message,$status);
}

add_action('admin_menu', 'add_warmth_option_page');
function add_warmth_option_page(){
	add_theme_page(__('Warmth Options','warmth'), __('Warmth Options','warmth'), 'edit_themes', basename(__FILE__), 'warmth_theme_options_page');
}

function warmth_theme_options_page(){
	global $warmth_options, $default_warmth_options, $warmth_db_options, $wp_version;
	if(isset($_POST['updateoptions'])){
		foreach((array) $default_warmth_options as $key => $defaultvalue) {
			$warmth_options[$key] = (isset($_POST[$key]) && !empty($_POST[$key])) ? stripslashes($_POST[$key]) : $defaultvalue;
		}
		if(update_option($warmth_db_options, $warmth_options)){
			$message = __('Settings saved','warmth');
			$status = 'updated fade';
		}else{
			$message = __('Update failed','warmth');
			$status = 'updated error';
		}
	}elseif( isset($_POST['reset_options']) ){
		update_option($warmth_db_options, $default_warmth_options);
		$warmth_options = $default_warmth_options;
		$message = __('confriguration has been reset back to default!');
		$status = 'updated fade';
	}else{
		$message = '';
		$status = '';
	}
?>

<div class="wrap">
	<style type="text/css">
fieldset {
-moz-border-radius:5px 5px 5px 5px;
border:1px solid #DDDDDD;
margin:5px 0 10px;
padding:5px 15px 15px;
}
fieldset legend {
color:#666666;
font-size:14px;
font-weight:700;
padding:0 5px;
}
	</style>
	<div class="icon32" id="icon-options-general"><br></div>
<h2><?php _e('Warmth Theme Options','warmth'); ?></h2>
<?php
	displayMessage($message,$status);
	unset($message,$status);
?>
<form action="" method="post" name="form1">
<table class="form-table optiontable">
<tbody>
<?php
/*
	<tr valign="top">
		<th scope="row">Front page displays</th>
		<td>
		<fieldset>
			<legend class="screen-reader-text"><span>Front page displays</span></legend>
			<label><input type="radio" checked="checked" class="tog" value="posts" name="show_on_front">Your latest posts</label>
			<p><label><input type="radio" class="tog" value="page" name="show_on_front">A <a href="edit-pages.php">static page</a> (select below)</label></p>
			<ul>
				<li><label for="page_on_front">Front page: <select id="page_on_front" name="page_on_front"><option value="">- Select -</option><option value="2" class="level-0">About</option></select></label></li>
				<li><label for="page_for_posts">Posts page: <select id="page_for_posts" name="page_for_posts"><option value="">- Select -</option><option value="2" class="level-0">About</option></select></label></li>
			</ul>
			<br />
			<small><em>(These settings may be overridden for individual articles.)</em></small>
		</fieldset>
		</td>
	</tr>
*/
?>
	<tr valign="top">
		<th scope="row"><?php _e('Post','warmth'); ?></th>
		<td>
		<fieldset>
			<legend class="screen-reader-text"><span>Excerpt for Post</span></legend>
			<label><input type="checkbox" name="excerpt" id="id_excerpt" value="yes" <?php if ($warmth_options['excerpt'] === 'yes') { ?> checked="checked"<?php } ?> /><?php _e('Excerpt with','warmth'); ?></label>
			<label><input type="text" class="small-text" name="fragmentnum" id="id_fragmentnum" value="<?php echo $warmth_options['fragmentnum']; ?>" /><?php _e('Paragraph Or','warmth'); ?></label>
			<label><input type="text" class="small-text" name="wordnum" id="id_wordnum" value="<?php echo $warmth_options['wordnum']; ?>" /><?php _e('Words','warmth'); ?></label>
		</fieldset>
		<?php if(strcmp($wp_version,'2.3')>=0) : ?>
		<fieldset>
			<legend class="screen-reader-text"><span>Related Posts</span></legend>
			<label><input type="checkbox" name="rel_post_c" id="id_rel_post_c" value="yes" <?php if ($warmth_options['rel_post_c'] === 'yes') { ?> checked="checked"<?php } ?> /><?php _e('Show','warmth'); ?></label>
			<label><input type="text" class="small-text" name="rel_post_num" id="id_rel_post_num" value="<?php echo $warmth_options['rel_post_num']; ?>" /><?php _e('Related Posts to the end of the article.','warmth'); ?></label>
			<br />
			<label><input type="checkbox" name="rel_post_feed_c" id="id_rel_post_feed_c" value="yes" <?php if ($warmth_options['rel_post_feed_c'] === 'yes') { ?> checked="checked"<?php } ?> /><?php _e('Embedded Related Posts to Feed.','warmth'); ?></label>
		</fieldset>
		<?php endif; ?>
		<fieldset>
			<legend class="screen-reader-text"><span>Random Posts</span></legend>
			<label><input type="checkbox" name="rand_post_c" id="id_rand_post_c" value="yes" <?php if ($warmth_options['rand_post_c'] === 'yes') { ?> checked="checked"<?php } ?> /><?php _e('Show','warmth'); ?></label>
			<label><input type="text" class="small-text" name="rand_post_num" id="id_rand_post_num" value="<?php echo $warmth_options['rand_post_num']; ?>" /><?php _e('Random Posts to the end of the article.','warmth'); ?></label>
			<br />
			<label><input type="checkbox" name="rand_post_feed_c" id="id_rand_post_feed_c" value="yes" <?php if ($warmth_options['rand_post_feed_c'] === 'yes') { ?> checked="checked"<?php } ?> /><?php _e('Embedded Random Posts to Feed.','warmth'); ?></label>
		</fieldset>
		</td>
	</tr>
	<!--
	<tr valign="top">
		<th scope="row"><?php _e('Search','warmth'); ?></th>
		<td>
			<label><input type="checkbox" name="cse_search_c" id="id_cse_search_c" value="yes" <?php if ($warmth_options['cse_search_c'] === 'yes') { ?> checked="checked"<?php } ?> /><?php _e('Use Customer Search with Name:','warmth'); ?></label><br />
			<input type="text" style="width:90%;margin-left:20px;" name="cse_search_cx" id="id_cse_search_cx" value="<?php echo htmlspecialchars(stripslashes($warmth_options['cse_search_cx'])); ?>" />
			<br />
			<small><?php printf(__('Find <code>name="cx"</code> in the <strong>Search box code</strong> of <a href="%1$s">Google Custom Search Engine</a>, and type the <code>value</code> here.<br/>For example: <code>002438711724093284343:5bdbzbqnuxa</code>', 'warmth'), 'http://www.google.com/coop/cse/'); ?></small>
		</td>
	</tr>
	-->
	<tr valign="top">
		<th scope="row"><?php _e('Rss Feed','warmth'); ?></th>
		<td>
			<label><input type="checkbox" name="rss_url_c" id="id_rss_url_c" value="yes" <?php if ($warmth_options['rss_url_c'] === 'yes') { ?> checked="checked"<?php } ?> /><?php _e('Use Customer Rss Feed with:','warmth'); ?></label><br />
			<input type="text" style="width:90%;margin-left:20px;" name="rss_url" id="id_rss_url" value="<?php echo htmlspecialchars(stripslashes($warmth_options['rss_url'])); ?>" />
		</td>
	</tr>
	<tr valign="top">
		<th scope="row"><?php _e('Comment','warmth'); ?></th>
		<td>
			<label><input type="checkbox" name="comment_submit" id="id_comment_submit" value="yes" <?php if ($warmth_options['comment_submit'] === 'yes') { ?> checked="checked"<?php } ?> /><?php _e('Submit comments with Ctrl+Enter.','warmth'); ?></label>
		</td>
	</tr>
	<tr valign="top">
		<th scope="row"><?php _e('Advertise Code','warmth'); ?></th>
		<td>
		<fieldset>
			<legend><label><input type="checkbox" name="ad1_c" id="id_ad1_c" value="yes" <?php if ($warmth_options['ad1_c'] === 'yes') { ?> checked="checked"<?php } ?> /><?php _e('Embedded advertising to article at the beginning.','warmth'); ?></label></legend>
			<p><label>Float: <input type="radio"<?php if ($warmth_options['ad1_float'] !== '1') { ?> checked="checked"<?php } ?> value="0" name="ad1_float">Left </label><label><input type="radio"<?php if ($warmth_options['ad1_float'] === '1') { ?> checked="checked"<?php } ?> value="1" name="ad1_float">Right</label></p>
			<p><textarea rows="5" style="width:90%;" name="ad1_text"><?php echo htmlspecialchars(stripslashes($warmth_options['ad1_text'])); ?></textarea></p>
		</fieldset>
		<fieldset>
			<legend><label><input type="checkbox" name="ad2_c" id="id_ad2_c" value="yes" <?php if ($warmth_options['ad2_c'] === 'yes') { ?> checked="checked"<?php } ?> /><?php _e('Embedded advertising to the end of the article.','warmth'); ?></label></legend>
			<p><textarea rows="5" style="width:90%;" name="ad2_text"><?php echo htmlspecialchars(stripslashes($warmth_options['ad2_text'])); ?></textarea></p>
		</fieldset>
		</td>
	</tr>
	<tr valign="top">
		<th scope="row"><?php _e('Web Analysis','warmth'); ?></th>
		<td>
		<fieldset>
			<legend><label><input type="checkbox" name="webanalysis_c" id="id_webanalysis_c" value="yes" <?php if ($warmth_options['webanalysis_c'] === 'yes') { ?> checked="checked"<?php } ?> /><?php _e('Embedded Web Ayalysis.','warmth'); ?></label></legend>
			<p><textarea rows="5" style="width:90%;" name="webanalysis_text"><?php echo htmlspecialchars(stripslashes($warmth_options['webanalysis_text'])); ?></textarea></p>
		</fieldset>
		</td>
	</tr>
</tbody>
</table>

<p class="submit">
	<input type="submit" class="button-primary" name="updateoptions" value="<?php _e('Save Changes','warmth'); ?>" />
	<input type="submit" class="button-primary"  name="reset_options" onclick="return confirm('<?php _e('Do you really want to reset your current configuration?','warmth'); ?>');" value="<?php _e('Reset Options','warmth'); ?>" />
</p>
</form>
</div><?php
}
?>